curl --request POST \
--url https://v1.orchestrator.rhinestone.dev/quotes/estimate \
--header 'Content-Type: application/json' \
--header 'x-api-key: <api-key>' \
--header 'x-api-version: <x-api-version>' \
--data '
{
"account": {
"evm": {
"type": "erc7579"
}
},
"source": {
"vm": "evm",
"chainId": "eip155:8453",
"token": "USDC",
"amount": "1000000",
"assumptions": {
"deployed": true
}
},
"destination": {
"vm": "evm",
"chainId": "eip155:42161",
"token": "0xaf88d065e77c8cc2239327c5edb3a432268e5831"
}
}
'import requests
url = "https://v1.orchestrator.rhinestone.dev/quotes/estimate"
payload = {
"account": { "evm": { "type": "erc7579" } },
"source": {
"vm": "evm",
"chainId": "eip155:8453",
"token": "USDC",
"amount": "1000000",
"assumptions": { "deployed": True }
},
"destination": {
"vm": "evm",
"chainId": "eip155:42161",
"token": "0xaf88d065e77c8cc2239327c5edb3a432268e5831"
}
}
headers = {
"x-api-version": "<x-api-version>",
"x-api-key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'x-api-version': '<x-api-version>',
'x-api-key': '<api-key>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
account: {evm: {type: 'erc7579'}},
source: {
vm: 'evm',
chainId: 'eip155:8453',
token: 'USDC',
amount: '1000000',
assumptions: {deployed: true}
},
destination: {
vm: 'evm',
chainId: 'eip155:42161',
token: '0xaf88d065e77c8cc2239327c5edb3a432268e5831'
}
})
};
fetch('https://v1.orchestrator.rhinestone.dev/quotes/estimate', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://v1.orchestrator.rhinestone.dev/quotes/estimate",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'account' => [
'evm' => [
'type' => 'erc7579'
]
],
'source' => [
'vm' => 'evm',
'chainId' => 'eip155:8453',
'token' => 'USDC',
'amount' => '1000000',
'assumptions' => [
'deployed' => true
]
],
'destination' => [
'vm' => 'evm',
'chainId' => 'eip155:42161',
'token' => '0xaf88d065e77c8cc2239327c5edb3a432268e5831'
]
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/json",
"x-api-key: <api-key>",
"x-api-version: <x-api-version>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://v1.orchestrator.rhinestone.dev/quotes/estimate"
payload := strings.NewReader("{\n \"account\": {\n \"evm\": {\n \"type\": \"erc7579\"\n }\n },\n \"source\": {\n \"vm\": \"evm\",\n \"chainId\": \"eip155:8453\",\n \"token\": \"USDC\",\n \"amount\": \"1000000\",\n \"assumptions\": {\n \"deployed\": true\n }\n },\n \"destination\": {\n \"vm\": \"evm\",\n \"chainId\": \"eip155:42161\",\n \"token\": \"0xaf88d065e77c8cc2239327c5edb3a432268e5831\"\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("x-api-version", "<x-api-version>")
req.Header.Add("x-api-key", "<api-key>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://v1.orchestrator.rhinestone.dev/quotes/estimate")
.header("x-api-version", "<x-api-version>")
.header("x-api-key", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"account\": {\n \"evm\": {\n \"type\": \"erc7579\"\n }\n },\n \"source\": {\n \"vm\": \"evm\",\n \"chainId\": \"eip155:8453\",\n \"token\": \"USDC\",\n \"amount\": \"1000000\",\n \"assumptions\": {\n \"deployed\": true\n }\n },\n \"destination\": {\n \"vm\": \"evm\",\n \"chainId\": \"eip155:42161\",\n \"token\": \"0xaf88d065e77c8cc2239327c5edb3a432268e5831\"\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://v1.orchestrator.rhinestone.dev/quotes/estimate")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["x-api-version"] = '<x-api-version>'
request["x-api-key"] = '<api-key>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"account\": {\n \"evm\": {\n \"type\": \"erc7579\"\n }\n },\n \"source\": {\n \"vm\": \"evm\",\n \"chainId\": \"eip155:8453\",\n \"token\": \"USDC\",\n \"amount\": \"1000000\",\n \"assumptions\": {\n \"deployed\": true\n }\n },\n \"destination\": {\n \"vm\": \"evm\",\n \"chainId\": \"eip155:42161\",\n \"token\": \"0xaf88d065e77c8cc2239327c5edb3a432268e5831\"\n }\n}"
response = http.request(request)
puts response.read_body{
"routes": [
{
"settlementLayer": "ACROSS",
"estimatedFillTime": {
"seconds": 3
},
"cost": {
"input": [
{
"chainId": "eip155:8453",
"tokenAddress": "0xaf88d065e77c8cc2239327c5edb3a432268e5831",
"symbol": "USDC",
"decimals": 6,
"price": {
"usd": 1
},
"amount": "1050000"
}
],
"output": [
{
"chainId": "eip155:8453",
"tokenAddress": "0xaf88d065e77c8cc2239327c5edb3a432268e5831",
"symbol": "USDC",
"decimals": 6,
"price": {
"usd": 1
},
"amount": "1050000"
}
],
"fees": {
"total": {
"usd": 0.029
},
"breakdown": {
"gas": {
"usd": 0.029,
"sponsored": false
},
"bridge": {
"usd": 0.029,
"sponsored": false
},
"swap": {
"usd": 0.029,
"sponsored": false
},
"app": {
"usd": 0.029,
"sponsored": false
},
"protocol": {
"usd": 0.029,
"sponsored": false
},
"sponsorSurcharge": {
"usd": 0.029,
"sponsored": false
}
}
}
},
"accuracy": "exact",
"status": "ok",
"assumptions": {
"account": {
"type": "erc7579",
"deployed": false
}
}
}
],
"unavailableReason": "unsupported_token"
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}Create Indicative Quote
Computes an indicative (non-binding) quote: ranked route estimates with per-route cost breakdown and fill time. Unlike POST /quotes, it returns no intentId, signingRequests, or expiresAt — it cannot be submitted to POST /intents. Use it for pre-quote UX (price previews, route discovery) without persisting an intent.
curl --request POST \
--url https://v1.orchestrator.rhinestone.dev/quotes/estimate \
--header 'Content-Type: application/json' \
--header 'x-api-key: <api-key>' \
--header 'x-api-version: <x-api-version>' \
--data '
{
"account": {
"evm": {
"type": "erc7579"
}
},
"source": {
"vm": "evm",
"chainId": "eip155:8453",
"token": "USDC",
"amount": "1000000",
"assumptions": {
"deployed": true
}
},
"destination": {
"vm": "evm",
"chainId": "eip155:42161",
"token": "0xaf88d065e77c8cc2239327c5edb3a432268e5831"
}
}
'import requests
url = "https://v1.orchestrator.rhinestone.dev/quotes/estimate"
payload = {
"account": { "evm": { "type": "erc7579" } },
"source": {
"vm": "evm",
"chainId": "eip155:8453",
"token": "USDC",
"amount": "1000000",
"assumptions": { "deployed": True }
},
"destination": {
"vm": "evm",
"chainId": "eip155:42161",
"token": "0xaf88d065e77c8cc2239327c5edb3a432268e5831"
}
}
headers = {
"x-api-version": "<x-api-version>",
"x-api-key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'x-api-version': '<x-api-version>',
'x-api-key': '<api-key>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
account: {evm: {type: 'erc7579'}},
source: {
vm: 'evm',
chainId: 'eip155:8453',
token: 'USDC',
amount: '1000000',
assumptions: {deployed: true}
},
destination: {
vm: 'evm',
chainId: 'eip155:42161',
token: '0xaf88d065e77c8cc2239327c5edb3a432268e5831'
}
})
};
fetch('https://v1.orchestrator.rhinestone.dev/quotes/estimate', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://v1.orchestrator.rhinestone.dev/quotes/estimate",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'account' => [
'evm' => [
'type' => 'erc7579'
]
],
'source' => [
'vm' => 'evm',
'chainId' => 'eip155:8453',
'token' => 'USDC',
'amount' => '1000000',
'assumptions' => [
'deployed' => true
]
],
'destination' => [
'vm' => 'evm',
'chainId' => 'eip155:42161',
'token' => '0xaf88d065e77c8cc2239327c5edb3a432268e5831'
]
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/json",
"x-api-key: <api-key>",
"x-api-version: <x-api-version>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://v1.orchestrator.rhinestone.dev/quotes/estimate"
payload := strings.NewReader("{\n \"account\": {\n \"evm\": {\n \"type\": \"erc7579\"\n }\n },\n \"source\": {\n \"vm\": \"evm\",\n \"chainId\": \"eip155:8453\",\n \"token\": \"USDC\",\n \"amount\": \"1000000\",\n \"assumptions\": {\n \"deployed\": true\n }\n },\n \"destination\": {\n \"vm\": \"evm\",\n \"chainId\": \"eip155:42161\",\n \"token\": \"0xaf88d065e77c8cc2239327c5edb3a432268e5831\"\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("x-api-version", "<x-api-version>")
req.Header.Add("x-api-key", "<api-key>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://v1.orchestrator.rhinestone.dev/quotes/estimate")
.header("x-api-version", "<x-api-version>")
.header("x-api-key", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"account\": {\n \"evm\": {\n \"type\": \"erc7579\"\n }\n },\n \"source\": {\n \"vm\": \"evm\",\n \"chainId\": \"eip155:8453\",\n \"token\": \"USDC\",\n \"amount\": \"1000000\",\n \"assumptions\": {\n \"deployed\": true\n }\n },\n \"destination\": {\n \"vm\": \"evm\",\n \"chainId\": \"eip155:42161\",\n \"token\": \"0xaf88d065e77c8cc2239327c5edb3a432268e5831\"\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://v1.orchestrator.rhinestone.dev/quotes/estimate")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["x-api-version"] = '<x-api-version>'
request["x-api-key"] = '<api-key>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"account\": {\n \"evm\": {\n \"type\": \"erc7579\"\n }\n },\n \"source\": {\n \"vm\": \"evm\",\n \"chainId\": \"eip155:8453\",\n \"token\": \"USDC\",\n \"amount\": \"1000000\",\n \"assumptions\": {\n \"deployed\": true\n }\n },\n \"destination\": {\n \"vm\": \"evm\",\n \"chainId\": \"eip155:42161\",\n \"token\": \"0xaf88d065e77c8cc2239327c5edb3a432268e5831\"\n }\n}"
response = http.request(request)
puts response.read_body{
"routes": [
{
"settlementLayer": "ACROSS",
"estimatedFillTime": {
"seconds": 3
},
"cost": {
"input": [
{
"chainId": "eip155:8453",
"tokenAddress": "0xaf88d065e77c8cc2239327c5edb3a432268e5831",
"symbol": "USDC",
"decimals": 6,
"price": {
"usd": 1
},
"amount": "1050000"
}
],
"output": [
{
"chainId": "eip155:8453",
"tokenAddress": "0xaf88d065e77c8cc2239327c5edb3a432268e5831",
"symbol": "USDC",
"decimals": 6,
"price": {
"usd": 1
},
"amount": "1050000"
}
],
"fees": {
"total": {
"usd": 0.029
},
"breakdown": {
"gas": {
"usd": 0.029,
"sponsored": false
},
"bridge": {
"usd": 0.029,
"sponsored": false
},
"swap": {
"usd": 0.029,
"sponsored": false
},
"app": {
"usd": 0.029,
"sponsored": false
},
"protocol": {
"usd": 0.029,
"sponsored": false
},
"sponsorSurcharge": {
"usd": 0.029,
"sponsored": false
}
}
}
},
"accuracy": "exact",
"status": "ok",
"assumptions": {
"account": {
"type": "erc7579",
"deployed": false
}
}
}
],
"unavailableReason": "unsupported_token"
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}{
"code": "VALIDATION_ERROR",
"message": "Invalid input",
"details": [
{
"message": "<string>",
"context": {}
}
]
}Authorizations
Project API key.
Headers
API version. Required; pinned to this document.
2026-09.caucasus Body
Indicative-quote request. Chain ids are CAIP-2 strings. The calculation follows the amount: source.amount is exact-in, destination.amount is exact-out; exactly one side carries an amount.
The hypothetical deposit being priced: one (chain, token) pair. Required; there is no balance to select over.
Show child attributes
Show child attributes
Where the estimate delivers
Show child attributes
Show child attributes
The account the estimate is calculated for. Optional: conservative defaults apply when it is omitted.
Show child attributes
Show child attributes
{ "evm": { "type": "erc7579" } }
Optional estimate tuning knobs
Show child attributes
Show child attributes
{ "sponsorship": { "gas": true } }
Response
OK
Response body for POST /quotes/estimate. Indicative (non-binding): carries no intentId, signingRequests, or expiresAt.
Was this page helpful?